import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

public class Guesser {

    private List _sources = new LinkedList();

    private SortedSet _bids = new TreeSet();

    public Guesser() {
        _sources.add(new Alphabet());
    }

    public Guess nextGuess(Message m) {
        _bids.clear();
        Iterator itr = _sources.iterator();
        while (itr.hasNext()) {
            KnowledgeSource k = (KnowledgeSource)itr.next();
            _bids.add(k.bidOn(m));
        }
        Bid b = (Bid)_bids.last();
        return b.getGuess();
    }

}
